# Lightweight Verification of Separate Compilation #

This is the supplementary materials for the submission #171 to POPL
2016: "Lightweight Verification of Separate Compilation".


## Contents ##

- `CompCert2.4/`: CompCert 2.4 with the following four patches applied:
    + Two bug-fixes are back-ported:
        * [More prudent analysis of uninitialized const global variables.](https://github.com/AbsInt/CompCert/commit/5aecefe)
        * [Protect against redefinition of the __i64_xxx helper library functions.](https://github.com/AbsInt/CompCert/commit/9f2ca10)
    + RTL-level optimization flags are introduced:
        * [Revised parsing of command-line arguments (in preparation for adding more).](https://github.com/AbsInt/CompCert/commit/f9b956b)
        * [Add flags to control individual optimization passes + flag -O0 for turning them off.](https://github.com/AbsInt/CompCert/commit/87b24bd)

- `levelA/`: Level A compositional verification of CompCert.

- `levelB/`: Level B compositional verification of CompCert.

- `count_locs.py`: Script that counts differences between `CompCert2.4/`
  and `level?/`. The table in the paper is automatically generated
  from this script.


## Notes ##

- We succeeded in compiling `CompCert2.4/`, `levelA/`, and `levelB/`
  directories with
  [Coq 8.4pl5](https://coq.inria.fr/distrib/V8.4pl5/files/) for all
  Linux targets by the following commands:
    + `./configure arm-linux; make depend; make`
    + `./configure ia32-linux; make depend; make`
    + `./configure ppc-linux; make depend; make`

- We recommend reviewers to use graphical diff tools, such as
  [meld](http://meldmerge.org/), for browsing our development.

- `count_locs.py` classifies added lines in `level?/` into two
  categories: (i) derived from CompCert 2.4, and (ii) newly
  written for SepCompCert.
    + Lines in newly created files are regarded as newly written,
      except for those lines starting with `(* copy *)`.
    + Lines in modified files are regarded as derived, except for
    those lines starting with `(* new *)`.

- CompCert generates `.v` files from `.vp` files, so build changes the
  lines of Coq code.  We counted number of lines before doing `make`.
